/* START_LICENSE_HEADER

Copyright (C) 2000 Martin Piper, original design and program code
Copyright (C) 2001-2005 Replica Software

This program file is copyright (C) Replica Software and can only be used under license.
For more information visit: http://www.replicanet.com/
Or email: info@replicanet.com

END_LICENSE_HEADER */
#ifndef __FREEWARECODE_H__
#define __FREEWARECODE_H__
#include "DLLExportAPI.h"

#ifdef __cplusplus
extern "C"
{
#endif

/// This allows users of the Freeware library to use their registration code so that other people running their application
/// do not need to install and register their own copy of the ReplicaNet SDK.
/// \param code The registration code to use
/// \return Returns true when there is no error.
REPNETEXPORTAPI bool FreewareSetRegistrationCode(const char *code);

#ifdef __cplusplus
}
#endif

#endif
